/**
 * Created by JetBrains WebStorm.
 * User: ConanLoxley
 * Date: 7/07/12
 * Time: 21:51
 */
var locale = null;

loader.addFinishHandler(function () {
    locale = qx.locale.Manager.getInstance().getLanguage();
});

var bosLocalizedStrings = {
    "en":{
        "summary":"Summary",
        "combat calculator":"Combat calculator",
        "food calculator":"Food calculator",
        "recruitment speed calculator":"Recruitment speed calculator",
        "jump to coords":"Jump to coords",
        "jump to city":"Jump to city",
        "please enter city coordinates":"Please enter city coordinates (for example 12:34) :",
        "jump to player":"Jump to player",
        "please enter player name:":"Please enter player name:",
        "jump to alliance":"Jump to alliance",
        "please enter alliance name:":"Please enter alliance name:",
        "error during BOS Tools menu creation: ":"Error during BOS Tools menu creation: ",
        "id":"Id",
        "cityId":"City Id",
        "from":"From",
        "type":"Type",
        "transport":"Transport",
        "state":"State",
        "start":"Start",
        "end":"End",
        "position":"Position",
        "target":"Target",
        "lastUpdated":"Last Updated",
        "resources":"Resources",
        "filter by trade type":"Filter by: <b>trade type</b>",
        "filter by: transport type":"Filter by: <b>transport type</b>",
        "filter by: resources receiver":"Filter by: <b>resources receiver</b>",
        "you":"You",
        "someone else":"Someone else",
        "filter by: state":"Filter by: <b>state</b>",
        "trade route":"Trade route",
        "OK":"OK",
        "clear":"Clear",
        "max":"Max",
        "please enter some resources amount":"Please enter some resources amount",
        "invalid destination":"Invalid destination",
        "to":"To",
        "ships then carts":"Ships then carts",
        "carts then ships":"Carts then ships",
        "only carts":"Only carts",
        "only ships":"Only ships",
        "group":"Group",
        "resourceMultiplierNotice":"if resourceCount < 10000 then resourceCount = resourceCount * 1000",
        "trade routes":"Trade Routes",
        "fromTo":"From/To",
        "action":"Action",
        "status":"Status",
        "wood":"Wood",
        "stone":"Stone",
        "iron":"Iron",
        "food":"Food",
        "land/sea":"Land/Sea",
        "edit":"Edit",
        "options":"Options",
        "table settings":"Table settings",
        "load table settings at start":"Load tables settings at start",
        "table name":"Table name",
        "cities":"Cities",
        "military":"Military",
        "btnLoadTableSettings":"Load table settings",
        "btnLoadTableSettings_toolTip":"Loads previously saved table settings (column order, widths, visibility, sort order)",
        "btnSaveTableSettings":"Save table settings",
        "btnSaveTableSettings_toolTip":"Saves table settings: column order, widths, visibility, sort order",
        "saving cities data":"Saving cities data",
        "cbPersistCities":"Save cities data",
        "cbPersistCities_toolTip":"After navigating to next city previous city is saved to browser local storage.",
        "cbLoadPersistedCitiesAtStart":"Load saved cities data at game start",
        "btnLoadCities":"Manually load saved cities data",
        "btnLoadCities_toolTip":"Manually loads cities data saved during previous game sessions",
        "btnDeleteAllSavedData":"Delete all saved data",
        "btnDeleteAllSavedData_confirmation":"All saved data has been deleted",
        "persistHelp":"When web browser session ends all data about visited cities are lost. Because of that on next game session summary widget doesn't contain a lot data. To enable better game experience there is possibility to save in persistent browser storage all data about visited cities and load them manually or automatically before showing summary. This feature works best if used together with 'Refresh resources' button.",
        "all":"All",
        "building":"Building",
        "castles":"Castles",
        "defensive":"Defensive",
        "warehouses":"Warehouses",
        "moonstones":"Moonstones",
        "gold":"Gold",
        "name":"Name",
        "reference":"Reference",
        "btnRefreshResources":"Refresh resources",
        "btnRefreshResources_toolTip":"Uses 'Request resources' functionality to get current resource levels.<br/>It won't be able to fetch information about cities without any <b>available</b> cart or ship.<br/>Processing request can take some time because it waits until server will respond.<br>Resources refreshed at: never",
        "purify resources":"Purify Resources",
        "btnPurifyAll":"Purify All",
        "btnPurifyAll_toolTip":"Purify resources for cities with <b>marked Moonglow Tower</b>.<br/>When Building Minister is present it will try not to purify food in city with negative food balance or in castles.<br/>If there is no Building Minister then it will skip castles.",
        "confirmation":"Confirmation",
        "are you sure?":"Are you sure?",
        "btnMarkMoonglowTower":"Mark Moonglow Tower",
        "btnMarkMoonglowTower_toolTip":"Finds in current city <b>Moonglow Tower</b> and saves it's id for later use",
        "btnUnmarkMoonglowTower":"Unmark Moonglow Tower",
        "btnUnmarkMoonglowTower_toolTip":"Unmarks previously saved <b>Moonglow Tower</b> in current city",
        "help":"Help",
        "_minimumResLevelInput_toolTip":"% of max storage that has to remain in each city after mass purification<br/>Manual purification is not affected by this setting",
        "_minimumResLevelInput_absolute_toolTip":"number of resources that has to remain in each city after mass purification<br/>Manual purification is not affected by this setting",
        "purificationHelp":"1. put *M* in city reference, by doing so city will be displayed in table below<br/>2. mark Moonglow Tower in cities enabled for 'Purify All'<br/>3. Use Purify all button or click in cell one of purified resource types",
        "purifiable":"Purifiable",
        "darkwood":"Darkwood",
        "runestone":"Runestone",
        "veritum":"Veritum",
        "trueseed":"Trueseed",
        "refresh":"Refresh",
        "sbSourceContinent_toolTip":"Filter by: <b>source continent</b>",
        "sbDestinationContinent_toolTip":"Filter by: <b>destination continent</b>",
        "defender":"Defender",
        "attacker":"Attacker",
        "btnUpdateView_toolTip":"Refresh View",
        "cbShowFakeAttacks":"Show fake attacks",
        "cbShowFakeAttacks_toolTip":"Fake attack is: plunder or siege or assault with TS < 4000",
        "unit orders":"Unit Orders",
        "incoming attacks":"Incoming attacks",
        "btnCsvExport":"Export Csv",
        "you need to be in city":"You need to be in city",
        "mass recruitment":"Mass Recruitment",
        "bos.gui.MassRecruitmentPage.help":"Currently requires Building Minister and War Minister. Persisting of cities and loading them on start have to be enabled or there will be popups saying to visit some city. Recruitment time is updated when enabling city for mass recruitment, if it changes enable it again. List of error codes:",
        "bos.gui.MassRecruitmentPage.help2":"I - Invalid, R - not enough Resources, Q - recruitment Queue is full, T - Troop limit exceeded, B - missing Building, G - not enough Gold",
        "city/order":"City / Orders",
        "missing":"Missing",
        "resourcesFor":"Resources for",
        "recruiting":"Recruiting",
        "available":"Available",
        "btnEnableMassRecruitment":"Enable",
        "btnEnableMassRecruitment_toolTip":"Enables current city for mass recruitment",
        "btnDisableMassRecruitment":"Disable",
        "btnDisableMassRecruitment_toolTip":"Disables current city from mass recruitment",
        "recruitmentTime":"Recruitment Time [s]",
        "btnRefreshView":"Refresh",
        "btnRefreshView_toolTip":"Refresh View",
        "btnRecruitAll":"Recruit All",
        "btnRecruitAll_toolTip":"Recruits all possible units",
        "btnDefenceMinisterSetTargetArmy":"Set target army",
        "btnDefenceMinisterSetTargetArmy_toolTip":"Use defense minister to set target army",
        "filter by: city types":"Filter by: <b>city types</b>",
        "purify":"Purify",
        "recruitment":"Recruitment",
        "carts":"Carts",
        "orders":"Orders",
        "wood/h":"Wood/h",
        "woodMax":"Wood max",
        "woodFree":"Wood free",
        "woodIncoming":"Wood incoming",
        "woodFullAt":"Wood full at",
        "stone/h":"Stone/h",
        "stoneMax":"Stone max",
        "stoneFree":"Stone free",
        "stoneIncoming":"Stone incoming",
        "stoneFullAt":"Stone full at",
        "iron/h":"Iron/h",
        "ironMax":"Iron max",
        "ironFree":"Iron free",
        "ironIncoming":"Iron incoming",
        "ironFullAt":"Iron full at",
        "food/h":"Food/h",
        "foodMax":"Food max",
        "foodFree":"Food free",
        "foodIncoming":"Food incoming",
        "foodFullAt":"Food full at",
        "gold/h":"Gold/h",
        "ships":"Ships",
        "buildQueue":"Build Queue",
        "unitQueue":"Unit Queue",
        "cbTweakReportAtStart":"Tweak reports at start",
        "cbTweakReportAtStart_toolTip":"When option is checked reports are tweaked at start",
        "recruit":"Recruit",
        "in city:":"Recruited: ",
        "add city units":"Add city units",
        "purify options":"Purify Options",
        "cbIncludeCastles":"Include castles",
        "cbIncludeCastles_toolTip":"Includes castles in mass purification.<br/>Without Building Minister it won't purify food in castle, with minister it can purify food as long as food balance is > 0",
        "cbUseRecruitmentData":"Uses Recruitment tab data",
        "cbUseRecruitmentData_toolTip":"Uses <strong>Recruitment</strong> tab data to check if some resource type is needed in castle to recruit missing troops",
        "btnPurifyOptions":"Options",

        "role":"Role",
        "lastLogin":"Last Login",
        "title":"Title",
        "rank":"Rank",
        "score":"Score",
        "continent":"Continent",
        "player name":"Player name",
        "land":"Land",
        "water":"Water",
        "palaces":"Palaces",
        "player":"Player",
        "my alliance":"My Alliance",
        "extra summary":"Extra Summary",
        "minScoreInput_toolTip":"Minimum score",
        "alliance":"Alliance",
        "zoom in":"Zoom in",
        "zoom out":"Zoom out",
        "jump to continent":"Jump to continent",
        "btnExportSettings":"Export settings",
        "btnExportSettings_toolTip":"Exports settings to text form",
        "btnImportSettings":"Import settings",
        "btnImportSettings_toolTip":"Imports settings. Currently saved settings will be discarded",
        "fetching resources, please wait":"Fetching resources, please wait",
        "btnFetchCities":"Fetch cities",
        "btnFetchCities_toolTip":"Simulates visiting city to fetch it's data. Function is called every 0.5s so it's slow",
        "btnTxtExport":"Text Export",

        "btnMarkAllMoonglowTowers":"Mark all MTs",
        "btnMarkAllMoonglowTowers_toolTip":"Marks moonglow towers in all cities",

        "btnAddIntel":"Add intel",
        "btnAddIntel_toolTip":"Add intelligence connected with enemy city",
        "isLandlocked":"Landlocked?",
        "hasCastle":"Castle?",
        "intelligence":"Intelligence",
        "delete":"Delete",
        "owner":"Owner",

        "fill with":"Fill with",
        "fill with resources":"Fill with resources",
        "resource type":"Resource type",
        "max resources to send":"Max resources to send",
        "max travel time":"Max travel time (h)",
        "cbAllowSameContinent":"Include cities from the same continent as target",
        "cbAllowOtherContinent":"Include cities from other continents than target",
        "cbPalaceSupport":"Palace delivery",
        "cbPalaceSupport_toolTip":"Sends resources as palace deliver (wood and stone only)",
        "current city":"Current city",
        "search":"Search",
        "request resources":"Request resources",

        "defenders":"Defenders",
        "btnSaveAllCities":"Save all cities",
        "save summary position":"Save summary position",

        "targetCityName":"Target City",
        "targetPosition":"Target Pos",
        "attackerCityName":"Attacker City",
        "attackerPosition":"Attacker Pos",
        "playerName":"Attacker",
        "allianceName":"Alliance",
        "attackerTS":"Attacker TS",
        "attackerUnits":"Attacker Units",
        "spotted":"Spotted",
        "claim":"Claim",
        "show intel":"Show intel",

        "btnCopyCityType2Group":"Assign",
        "btnCopyCityType2Group_toolTip":"For each city of given BOS type (set in reference) assigns EA city group",

        "":""
    },
    "de":{
        "summary":"Übersicht",
        "combat calculator":"Kampf Kalkulator",
        "food calculator":"Nahrungsberechner",
        "recruitment speed calculator":"Rekrutiergeschwinigkeitsberechnung",
        "jump to coords":"Gehe zu",
        "jump to city":"Gehe zu City",
        "please enter city coordinates":"Bitte gebe Stadtkoordinaten (z.B.: 12:34) ein",
        "jump to player":"Gehe zu Spieler",
        "please enter player name:":"Bitte gebe einen Spielernamen ein",
        "jump to alliance":"Gehe zu Allianz",
        "please enter alliance name:":"Bitte gib den Namen der Allianz ein",
        "error during BOS Tools menu creation: ":"Error bei der Erstellung des BOS-Tool Menüs:",
        "id":"Id",
        "cityId":"Stadt Id",
        "from":"von",
        "type":"Handelstyp",
        "transport":"Transporttyp",
        "state":"Status",
        "start":"Aufbruchszeit",
        "end":"Ankunft",
        "position":"Pos",
        "target":"Ziel",
        "lastUpdated":"Zuletzt aktualisiert",
        "resources":"Ressourcen",
        "filter by trade type":"Filtere nach <b>Transportart</b> ",
        "filter by: transport type":"Filtere nach <b>Transporttyp</b>",
        "filter by: resources receiver":"Filtere nach <b>Ressourcenempfänger</b>",
        "you":"Du",
        "someone else":"Jemand andres",
        "filter by: state":"Filtere nach <b>Status</b>",
        "trade route":"Handelsroute",
        "OK":"OK",
        "clear":"Löschen",
        "max":"Max",
        "please enter some resources amount":"Bitte gib die Anzahl der Ressourcen ein",
        "invalid destination":"Ungültiges Ziel",
        "to":"zu",
        "ships then carts":"Schiffe über Karren", /* 100% accurate translation would be "erst Handelschiffe, dann Marktkarren" there was soneone else who
         translated things too maybe you should let him check what to do*/
        "carts then ships":"Karren vor Schiffen", /*same as above just inversed*/
        "only carts":"Nur Karren",
        "only ships":"Nur Schiffe",
        "group":"Gruppe",
        "resourceMultiplierNotice":"if resourceCount < 10000 then resourceCount = resourceCount * 1000",
        "trade routes":"Handelsrouten",
        "fromTo":"Von/Zu",
        "action":"Aktion",
        "status":"Status",
        "wood":"Holz",
        "stone":"Stein",
        "iron":"Eisen",
        "food":"Nahrung",
        "land/sea":"Land/See",
        "edit":"Bearbeiten",

        "options":"Optionen",
        "table settings":"Tabelleneinstellungen",
        "load table settings at start":"Lade Tabelleneinstellungen beim Start",
        "table name":"Tabellenname",
        "cities":"Städte",
        "military":"Militär",
        "btnLoadTableSettings":"Lade Tabelleneinstellungen",
        "btnLoadTableSettings_toolTip":"Lädt die (vorher) gespeicherten Einstellungen für die Tabelle (Spaltenordnung, Spaltenbreite, angezeigte Felder, Sortierordnung",
        "btnSaveTableSettings":"Speichern der Tabelleneigenschaften",
        "btnSaveTableSettings_toolTip":"Speichert die Tabelleneigenschaften: Spaltenordnung, Spaltenbreite, Angezeigte Spalten, Sortierordnung",
        "saving cities data":"Speichern der Stadtdaten",
        "cbPersistCities":"Speicher Stadtdaten",
        "cbPersistCities_toolTip":"Wenn du zur nächsten Stadt wechselst, werden die Daten der vorherigen im lokalen Speicher des Browers gespeichert.",
        "cbLoadPersistedCitiesAtStart":"Lade gespeicherte Stadtdaten beim Start des Spieles",
        "btnLoadCities":"Lade gespeicherte Stadtdaten manuell",
        "btnLoadCities_toolTip":"Läd manuell die Stadtdaten einer verherigen LoU-Session ",
        "btnDeleteAllSavedData":"Lösche alle gespeicherten Daten",
        "btnDeleteAllSavedData_confirmation":"Alle gespeicherten Daten wurden gelöscht!",
        "persistHelp":"Wenn Lord of Ultima beendet wird gehen alle Daten der besuchten Städte verloren. Deswegen sind beim nächsten Start von LoU nicht viele bzw. keine Daten im der Tabelle. Dies kann man verhindern, indem man die Daten der Städte im lokalen Speicher des Browsers speichert und sie automatisch oder manuell laden lässt. Diese Einstellung funktioniert am besten, wenn sie zusammen mit `Ressourcen aktualisieren` verwendet wird.",
        "all":"Alle",
        "building":"In Bau/Aufbau",
        "castles":"Burgen",
        "defensive":"Defensive",
        "warehouses":"Lager",
        "moonstones":"Mondsteine",
        "gold":"Geld",
        "name":"Name",
        "reference":"Referenz",
        "btnRefreshResources":"Ressourcen aktualisieren",
        "btnRefreshResources_toolTip":"Benutzt die 'Request resources' Funktion umd die momentanen Ressourcen der Städte zu bekommen.<br/>Dies funktioniert nur bei Städten mit <b>vorhandenen</b> Marktkarren oder Handelsschiffen.<br/>Das sammeln aller Ressourcen kann einige Zeit dauern, da immer auf Antwort des Servers gewartet wird.<br/>Ressourcen wurden aktualisiert am: nie",
        "purify resources":"Ressourcen veredeln",
        "btnPurifyAll":"Veredele alle",
        "btnPurifyAll_toolTip":"Veredelt Ressurcen in Städten mit <b>markiertem Mondschein-Turm</b>.<br/>Falls ein Bauminister aktiv ist, so wird versucht keine Ressurcen zu veredeln in Städten/Burgen mit negativer Nahrungbalance.<br/>Wenn kein Bauminister aktiv ist werden Burgen übersprungen.",
        "confirmation":"Bestätigung",
        "are you sure?":"Bist du sicher?",
        "btnMarkMoonglowTower":"Markiere einen Mondschein-Turm",
        "btnMarkMoonglowTower_toolTip":"Sucht in der Stadt nach einem <b>Mondschein-Turm</b> und speichert die ID für die weitere Benutzung",
        "btnUnmarkMoonglowTower":"Lösche Mondstein-Turm Markierung",
        "btnUnmarkMoonglowTower_toolTip":"Löscht alle markierten<b>Mondstein-Türme</b> in dieser Stadt<br/>",

        "_minimumResLevelInput_toolTip":"% der max. Lagerkapzität, welche in jeder Stadt nach der Massenveredlung bestehen bleiben muss.<br/>Manuelle Veredlung ist hiervon nicht betroffen",
        "_minimumResLevelInput_absolute_toolTip":"Anzahl der Ressurcen,  welche in jeder Stadt nach der Massenveredlung bestehen bleiben muss.<br/>Manuelle Veredlung ist hiervon nicht betroffen",
        "purificationHelp":"1. schreibe *M* in die Stadtreferenz, damit die Stadt in der Veredelungstabelle angezeigt wird.<br/>2. Markiere den Monddstein-Turm in der Stadt umd diese Stadt für die Massenveredelung freizuschalten<br/>3. Klicke den Veredele alle \"Button\" oder klicke in das Kästchen des zuveredelnden Ressourcentypes",
        "purifiable":"veredeDunkelholzDarkwood",
        "runestone":"Runensteine",
        "veritum":"Veritum",
        "trueseed":"Trueseed",
        "refresh":"Aktualisieren",
        "sbSourceContinent_toolTip":"Filtern nach: <b>Herrkunftskontinent</b>",
        "sbDestinationContinent_toolTip":"Filtern nach: <b>Zielkontinent</b>",
        "defender":"Verteidiger",
        "attacker":"Angreifer",
        "btnUpdateView_toolTip":"Ansicht aktualisieren",
        "cbShowFakeAttacks":"Zeige Fake-Angriffe",
        "cbShowFakeAttacks_toolTip":"Fake-Angriffe sind: Plünderungen/Überfälle/Belagerungen mit einer TS < 1000",
        "unit orders":"Einheitenbefehle",
        "incoming attacks":"Eingehende Angriffe",
        "btnCsvExport":"Export Csv",
        "you need to be in city":"Du musst in der Stadt sein um die Verteidigung und die Verteidiger zu erhalten!",
        "mass recruitment":"Massrekrutierung",
        "bos.gui.MassRecruitmentPage.help":"Benötigt zur Zeit einen Bau- und Kiegsminister. Persisting of cities and 'Lade bei Start' muss aktiviert werden oder es werden Popups erscheinen, welche bvesagen, dass eine Stadt besucht werden soll. Rekruierzeiten werden aktualiesiert wenn die Massenrekrutierung für die jeweilige Stadt aktiviert wird, falls die Zeiten sich ändern, aktiviere die Massenrekrutierung erneut. Liste der Errormeldungen:",
        "bos.gui.MassRecruitmentPage.help2":"I - Ungültig (Invalid), R - nicht genügend Resourcen, Q - Rekrutierliste ist voll (recruitment Queue), T - Truppenlimit erreicht, B - Fehlendes Einheitengebäude, G - nicht genug Gold",
        "city/order":"Stadt / Befehle",
        "missing":"Fehlend",
        "resourcesFor":"Ressourcen für",
        "recruiting":"Rekrutiert",
        "available":"Verfügbar",
        "btnEnableMassRecruitment":"Aktivieren",
        "btnEnableMassRecruitment_toolTip":"Schaltet die momentane Stadt für Massenrekrutierung",
        "btnDisableMassRecruitment":"Deaktivierung",
        "btnDisableMassRecruitment_toolTip":"Deaktiviert Massenrekrutierung für die momentane Stadt",
        "recruitmentTime":"Rekrutierzeit [s]",
        "btnRefreshView":"Aktualisieren",
        "btnRefreshView_toolTip":"Ansicht aktualisieren",
        "btnRecruitAll":"Rekrutiere alle",
        "btnRecruitAll_toolTip":"Rekrutiert alle Verfügbaren Einheiten",
        "btnDefenceMinisterSetTargetArmy":"Set target army",
        "btnDefenceMinisterSetTargetArmy_toolTip":"Use defense minister to set target army",
        "filter by: city types":"Filtern nach: <b>Stadttyp</b>",
        "purify":"Veredeln",
        "recruitment":"Rekrutieren",
        "carts":"Karren",
        "orders":"Orders",
        "wood/h":"Holz/h",
        "woodMax":"max. Holz",
        "woodFree":"freie Holzkapazität",
        "woodIncoming":"eintreffendes Holz",
        "woodFullAt":"Holz voll am/um",
        "stone/h":"Stein/h",
        "stoneMax":"max. Stein",
        "stoneFree":"freie Steinkapazität",
        "stoneIncoming":"eintreffende Steine",
        "stoneFullAt":"Stein voll am/um",
        "iron/h":"Eisen/h",
        "ironMax":"max. Eisen",
        "ironFree":"freie Eisenkapazität",
        "ironIncoming":"eiintreffendes Eisen",
        "ironFullAt":"Eisen voll am/um",
        "food/h":"Nahrung/h",
        "foodMax":"max. Nahrung",
        "foodFree":"freie Nahrungskapazität",
        "foodIncoming":"eintreffende Nahrung",
        "foodFullAt":"Nahrung voll am/um",
        "gold/h":"Gold/h",
        "ships":"Handelsschiffe",
        "buildQueue":"Bauliste",
        "unitQueue":"Rekrutierliste",
        "cbTweakReportAtStart":"Tweak Report beim Start",
        "cbTweakReportAtStart_toolTip":"Läd die Tweak-Reports beim Start",
        "recruit":"Rekrutiere",
        "in city:":"Rekrutiert: ",
        "add city units":"Füge Einheiten dieser Stadt hinzu",
        "purify options":"Veredelungsoptionen",
        "cbIncludeCastles":"Schließe Burgen mit ein",
        "cbIncludeCastles_toolTip":"Schließt Burgen in die Massenveredelung ein.<br/>Ohne Bauminister wird keine Nahrung ist Burgen veredelt. Falls vorhanden wird Nahrung nur in Burgen mit positiver Nahrungsbalance veredelt",
        "cbUseRecruitmentData":"Uses Recruitment tab data",
        "cbUseRecruitmentData_toolTip":"Benutzt die <strong>Rekrutiertab</strong>-Daten um zu kontrollieren ob Ressourcen für die fehlenden Einheiten in der Burg benötigt werden",
        "btnPurifyOptions":"Optionen",

        "role":"Role",
        "lastLogin":"Last Login",
        "title":"Title",
        "rank":"Rank",
        "score":"Score",
        "continent":"Continent",
        "player name":"Player name",
        "land":"Land",
        "water":"Water",
        "palaces":"Palaces",
        "player":"Player",
        "my alliance":"My Allianz",
        "extra summary":"Extra Summary",
        "minScoreInput_toolTip":"Minimum score",
        "alliance":"Allianz",
        "zoom in":"Zoom in",
        "zoom out":"Zoom out",
        "btnExportSettings":"Export settings",
        "btnExportSettings_toolTip":"Exports settings to text form",
        "btnImportSettings":"Import settings",
        "btnImportSettings_toolTip":"Imports settings. Currently saved settings will be discarded",
        "fetching resources, please wait":"Lade Ressourcen..",
        "btnFetchCities":"Fetch cities",
        "btnFetchCities_toolTip":"Simulates visiting city to fetch it's data. Function is called every 0.5s so it's slow",
        "btnTxtExport":"Text Export",

        "":""
    },
    "pl":{
        "summary":"BOS Przegląd",
        "combat calculator":"Kalkulator bitew",
        "food calculator":"Kalkulator jedzenia",
        "recruitment speed calculator":"Kalkulator szybkości rekrutacji",
        "jump to coords":"Skocz do współrzędnych",
        "jump to city":"Skocz do miasta",
        "please enter city coordinates":"Wprowadź współrzędne (np. 12:34) :",
        "jump to player":"Skocz do gracza",
        "please enter player name:":"Wprowadź nazwę gracza:",
        "jump to alliance":"Skocz do sojuszu",
        "please enter alliance name:":"Wprowadź nazwę sojuszu:",
        "error during BOS Tools menu creation: ":"Błąd podczas tworzenia BOS Tools: ",
        "id":"Id",
        "cityId":"Miasto Id",
        "from":"Skąd",
        "type":"Typ",
        "transport":"Transport",
        "state":"Stan",
        "start":"Start",
        "end":"Koniec",
        "position":"Pozycja",
        "target":"Cel",
        "lastUpdated":"Ost. Aktualizacja",
        "resources":"Zasoby",
        "filter by trade type":"Filtruj po: <b>typie handlu</b>",
        "filter by: transport type":"Filtruj po: <b>typie transportu</b>",
        "filter by: resources receiver":"Filtruj po: <b>odbiorcy zasobów</b>",
        "you":"Ty",
        "someone else":"Ktoś inny",
        "filter by: state":"Filtruj po: <b>stanie</b>",
        "trade route":"Szlak handlowy",
        "OK":"OK",
        "clear":"Wyczyść",
        "max":"Max",
        "please enter some resources amount":"Wprowadź liczbę surowców",
        "invalid destination":"Nieprawidłowe miejsce docelowe",
        "to":"Do",
        "ships then carts":"Statki później wozy",
        "carts then ships":"Wozy później statki",
        "only carts":"Tylko wozy",
        "only ships":"Tylko statki",
        "group":"Grupa",
        "resourceMultiplierNotice":"jeżeli liczbaZasobów < 10000 to liczbaZasobów = liczbaZasobów * 1000",
        "trade routes":"Szlaki Handlowe",
        "fromTo":"Skąd/Dokąd",
        "action":"Akcja",
        "status":"Status",
        "wood":"Drewno",
        "stone":"Kamień",
        "iron":"Żelazo",
        "food":"Jedzenie",
        "land/sea":"Ląd/Morze",
        "edit":"Edycja",
        "options":"Opcje",
        "table settings":"Ustawienia tabel",
        "load table settings at start":"Ładuj ustawienia tabel przy starcie",
        "table name":"Nazwa tabeli",
        "cities":"Miasta",
        "military":"Wojsko",
        "btnLoadTableSettings":"Wczytaj ustawienia tabeli",
        "btnLoadTableSettings_toolTip":"Ładuje poprzednio zapisane ustawienia tabel (porządek kolumn, szerokości, widoczność, porządek sortowania)",
        "btnSaveTableSettings":"Zapisz ustawienia tabeli",
        "btnSaveTableSettings_toolTip":"Zapisuje ustawienia tabeli: porządek kolumn, szerokości, widoczność, porządek sortowania.<br/>Ciągle musisz kliknąć przycisk <b>Zapisz</b> celem zapisania tego na stałe",
        "saving cities data":"Zapisuje dane miast",
        "cbPersistCities":"Zapisz dane miast",
        "cbPersistCities_toolTip":"Po udaniu się do kolejnego miasta stan poprzedniego miasta zapisany jest w local storage przeglądarki.",
        "cbLoadPersistedCitiesAtStart":"Załaduj zapisane miasta przy starcie gry",
        "btnLoadCities":"Manualnie załaduj dane miast",
        "btnLoadCities_toolTip":"Manualnie ładuje dane miast zapisane podczas poprzednich sesji z grą",
        "btnDeleteAllSavedData":"Skasuj wszystkie zapisane dane",
        "btnDeleteAllSavedData_confirmation":"Wszystkie dane zostały skasowane",
        "persistHelp":"Normalnie kiedy sesja przeglądarki zostaje zakończona wszystkie informacje o odwiedzonych miastach są tracone. Z tego powodu podsuwanie nie będzie zawierać wielu danych. Z tego powodu możliwe jest zapisanie informacji o odwiedzonych miastach w lokalnej bazie danych dostępnej w nowoczesnej przeglądarce internetowej.",
        "all":"Wszystko",
        "building":"W budowie",
        "castles":"Zamki",
        "defensive":"Defensywne",
        "warehouses":"Składy",
        "moonstones":"Moonstones",
        "gold":"Złoto",
        "name":"Nazwa",
        "reference":"Uwagi",
        "btnRefreshResources":"Odśwież surowce",
        "btnRefreshResources_toolTip":"Używa funkcjonalności 'Poproś o surowce' celem otrzymania aktualnych ilości surowców.<br/>Nie będzie w stanie poobrać informacji dla miast nie posiadających żadnych <b>dostępnych</b> statków lub wozów.<br/>Przetwarzanie żądania może zabrać trochę czasu z uwagi na czas odpowiedzi serwera.<br>Zasoby odświeżono: nigdy",
        "purify resources":"Oczyszczanie zasobów",
        "btnPurifyAll":"Oczyść wszystko",
        "btnPurifyAll_toolTip":"Oczyszcza zasoby w miastach posiadających <b>oznaczoną Wieżę Księżycową</b>.<br/>Gdy dostępny jest Minister Budownictwa jedzenie nie zostanie oczywszczone w miastach o ujemnym bilansie jedzenia oraz w zamkach.<br/>Jeżeli gracz nie posiada Ministra Budownictwa podczas oczyszczania pominięte zostaną zamki.",
        "confirmation":"Potwierdzenie",
        "are you sure?":"Czy jesteś pewien?",
        "btnMarkMoonglowTower":"Oznacz Wieżę Księżycową",
        "btnMarkMoonglowTower_toolTip":"Znajduje w aktualnym mieście <b>Wieżę Księżycową</b> i zapisuje ją celem późniejszego użycia",
        "btnUnmarkMoonglowTower":"Odznacz Wieżę Księżycową",
        "btnUnmarkMoonglowTower_toolTip":"Dla aktualnego miasta odznacza uprzednio zaznaczoną <b>Wieżę Księżycową<b>",
        "help":"Pomoc",
        "_minimumResLevelInput_toolTip":"% of max storage that has to remain in each city after mass purification<br/>Manual purification is not affected by this setting",
        "_minimumResLevelInput_absolute_toolTip":"number of resources that has to remain in each city after mass purification<br/>Manual purification is not affected by this setting",
        "purificationHelp":"1. umieść *M* uwagach dotyczących miasta dzięki czemu miasto będzie widoczne w poniżej tabeli<br/>2. Oznacz Wieżę Księżycową dla miast mających brać udział w 'Oczyść wszystko'<br/>3. Użyj przycisku 'Oczyść wszystko' lub kliknij w komórce odpowiadającej oczyszczonym typom surowców",
        "purifiable":"Oczyszczalne",
        "darkwood":"Ciemnolas",
        "runestone":"Kamień runiczny",
        "veritum":"Veritum",
        "trueseed":"Magiczny pokarm",
        "refresh":"Odśwież",
        "sbSourceContinent_toolTip":"Filtruj po: <b>kontynencie źródłowym</b>",
        "sbDestinationContinent_toolTip":"Filtruj po: <b>kontynencie docelowym</b>",
        "defender":"Obrońca",
        "attacker":"Atakujący",
        "btnUpdateView_toolTip":"Odśwież widok",
        "cbShowFakeAttacks":"Pokazuj ataki pozorowane",
        "cbShowFakeAttacks_toolTip":"Atak pozorowany to: grabież, oblężenie lub szturm o SO < 1000",
        "unit orders":"Rozkazy",
        "incoming attacks":"Nadchodzące ataki",
        "btnCsvExport":"Export Csv",
        "you need to be in city":"Musisz być w mieście",
        "mass recruitment":"Masowa rekrutacja",
        "bos.gui.MassRecruitmentPage.help":"Aktualnie wymaga Ministra Budownictwa i Ministra Wojny. Zapisywane miast i ładowanie ich na stracie musi być załączone. W przyciwnym razie będą wyskakiwać błędu nakazujące odwiedzić jakieś miasto. Czas rekrutacji jest aktualizowany podczas załączania miasta miasto do masowej rekrutacji, jeśli ulegnie zmianie - dodaj miasto raz jeszcze. Lista kodów błędu:",
        "bos.gui.MassRecruitmentPage.help2":"I - Nieprawidłowy, R - za mało surowców, Q - kolejka rekrutacji jest pełna, T - przekroczono SO, B - brakuje budynku, G - za mało złota",
        "city/order":"Miasto / Rozkazy",
        "missing":"Brakuje",
        "resourcesFor":"Surowców dla",
        "recruiting":"Rekrutuje",
        "available":"Dostępne",
        "btnEnableMassRecruitment":"Załącz",
        "btnEnableMassRecruitment_toolTip":"Załącza miasto do masowej rekrutacji",
        "btnDisableMassRecruitment":"Wyłącz",
        "btnDisableMassRecruitment_toolTip":"Wyłącza miasto z masowej rekrutacji",
        "recruitmentTime":"Czas rekrutacji [s]",
        "btnRefreshView":"Odśwież",
        "btnRefreshView_toolTip":"Odśwież widok",
        "btnRecruitAll":"Rekrutuj Wszystko",
        "btnRecruitAll_toolTip":"Rekrutuje wszystkie możliwe jednostki",
        "btnDefenceMinisterSetTargetArmy":"Set target army",
        "btnDefenceMinisterSetTargetArmy_toolTip":"Use defense minister to set target army",
        "filter by: city types":"Filtruj po: <b>typach miast</b>",
        "purify":"Oczyść",
        "recruitment":"Rekrutacja",
        "carts":"Wozy",
        "orders":"Rozkazy",
        "wood/h":"Drewno/h",
        "woodMax":"Drewno max",
        "woodFree":"Drewno wolne",
        "woodIncoming":"Drewno nadchodzi",
        "woodFullAt":"Drewno pełne",
        "stone/h":"Kamień/h",
        "stoneMax":"Kamień max",
        "stoneFree":"Kamień wolne",
        "stoneIncoming":"Kamień nadchodzi",
        "stoneFullAt":"Kamień pełne",
        "iron/h":"Żelazo/h",
        "ironMax":"Żelazo max",
        "ironFree":"Żelazo wolne",
        "ironIncoming":"Żelazo nadchodzi",
        "ironFullAt":"Żelazo pełne",
        "food/h":"Jedzenie/h",
        "foodMax":"Jedzenie max",
        "foodFree":"Jedzenie wolne",
        "foodIncoming":"Jedzenie nadchodzi",
        "foodFullAt":"Jedzenie pełne",
        "gold/h":"Złoto/h",
        "ships":"Statki",
        "buildQueue":"Kolejka Budowy",
        "unitQueue":"Kolejka Rekrutacji",
        "cbTweakReportAtStart":"Podrasuj raporty na starcie",
        "cbTweakReportAtStart_toolTip":"Gdy załączone raporty są podrasowane na starcie",
        "recruit":"Rekrutuj",
        "in city:":"Zrekrutowano: ",
        "add city units":"Dodaj jednostki miasta",
        "purify options":"Opcje Oczyszczania",
        "cbIncludeCastles":"Załącz zamki",
        "cbIncludeCastles_toolTip":"Załącza zamki do masowego oczyszczania.<br/>Bez Ministra Handlu nie oczyści jedzenia w zamku, z ministrem zrobi to o ile bilans jedzenia jest dodatni",
        "cbUseRecruitmentData":"Używaj masową rekrutację",
        "cbUseRecruitmentData_toolTip":"Używa zakładki <strong>Rekrutacja</strong> do sprawdzenia jakie typy surowców są potrzebne celem rekrutacji brakujących jednostek",
        "btnPurifyOptions":"Opcje",

        "role":"Rola",
        "lastLogin":"Ostatnie Logowanie",
        "title":"Tytuł",
        "rank":"Ranga",
        "score":"Punkty",
        "continent":"Kontynent",
        "player name":"Nazwa gracza",
        "land":"Ląd",
        "water":"Woda",
        "palaces":"Pałace",
        "player":"Gracz",
        "my alliance":"Mój sojusz",
        "extra summary":"Extra Przegląd",
        "minScoreInput_toolTip":"Minimalna liczba punktów",
        "alliance":"Sojusz",
        "zoom in":"Przybliż",
        "zoom out":"Oddal",
        "jump to continent":"Skocz do kontynentu",
        "btnExportSettings":"Eksportuj ustawienia",
        "btnExportSettings_toolTip":"Eksportuje ustawienia do postaci tekstowej",
        "btnImportSettings":"Importyj ustawienia",
        "btnImportSettings_toolTip":"Importuje ustawienia. Aktualne ustawienia zostaną usunięte",
        "fetching resources, please wait":"Pobieram zasoby, proszę czekać",
        "btnFetchCities":"Pobierz miasta",
        "btnFetchCities_toolTip":"Symuluje odwiedziny miast, aby pobrać ich dane. Funkcja wywoływan jest co 0.5s tak więc jest to wolne przy dużej liczbie miast",
        "btnTxtExport":"Eksport tekstowy",

        "":""
    }
};

/**
 * Translation function
 * @param {string} messageId - key of the message to localize
 * @return {string} - localized message
 */
function tr(messageId) {
    var language = qx.locale.Manager.getInstance().getLanguage();

    if (bosLocalizedStrings[language] != undefined && bosLocalizedStrings[language][messageId] != undefined) {
        return bosLocalizedStrings[language][messageId];
    }

    if (bosLocalizedStrings["en"][messageId] != undefined) {
        return bosLocalizedStrings["en"][messageId];
    }

    return messageId;
}
