
function paTweak3_checkIfLoaded() {

    console.log("[paTweak3_checkIfLoaded] Try loading paTweak3");

    try {
        if (typeof qx != 'undefined') {
            var app = qx.core.Init.getApplication();
            var locale = qx.locale.Manager.getInstance();
            var res = webfrontend.res.Main.getInstance();

            if (app && locale && res && res.dungeons) {
                console.log("[paTweak3_checkIfLoaded] Initialize paTweak3.main");

                paTweak.pakMap.init(app, res, locale.getLanguage());
                app.worldViewToolTip.addListener("appear", paTweak.pakMap.toolTipAppear);

                paTweak.Main.getInstance().initialize();
            } else {
                console.log("[paTweak3_checkIfLoaded] Retrying in a second because application is not yet ready");
                window.setTimeout(paTweak3_checkIfLoaded, 1000);
            }
        } else {
            console.log("[paTweak3_checkIfLoaded] Retrying in a second because application is not yet ready");
            window.setTimeout(paTweak3_checkIfLoaded, 1000);
        }
    } catch (e) {
        if (typeof console != 'undefined') console.log(e);
        else if (window.opera) opera.postError(e);
    }
}

loader.addFinishHandler(paTweak3_checkIfLoaded);