﻿/**
 * Created by TriMoon <http://claimid.com/trimoon>
 * Date: 2012/08/29
 * LoU Tweak:
 * 		Author: AmpliDude
 * 		Script: http://userscripts.org/scripts/show/80532
 */
function L(str) {
	return LT_strings[window.louTweak.main.getInstance().getLang()][str];
};

loader.addFinishHandler(function() {

	LT_strings = {
		"0": { /* english */
			"options_btn_tt": "Click to show LoU Tweak Options",
			"layout_btn_tt": "Click to generate layout Sharestring for current city",
			"chat_btn_city": "City",
			"chat_btn_player": "Player",
			"chat_btn_alliance": "Alliance",
			"chat_btn_url": "Link",
			"copy_coords_btn": "Copy coordinates to chat",
			"up_count_tt": "Buildings available for upgrade:",
			"opts_max_chatlines": "Maximum lines of chat:",
			"opts_chat_opacity": "Chat background transparency:",
			"opts_switch_to_ally_tab": "Switch to Alliance Tab at start",
			"opts_show_queue_win": "Show queue info window",
			"opts_limit_req_res": "Limit requested resources to city free space",
			"opts_inc_res": {
				"lab": "Incoming resources label:",
				"disabled": "Disabled",
				"always": "Always on",
				"context": "Contextual"
			},
			"opts_separator": {
				"lab": "Thousands separator:",
				"period": "'.' (period)",
				"comma": "',' (comma)",
				"space": "' ' (space)",
				"none": "none"
			},
			"opts_city_tag": {
				"lab": "[city] tag shows:",
				"info": "City info",
				"region": "Region view"
			},
			"opts_lowest_lvl": {
				"lab1": "Select buildings that you want to upgrade with 'L (upgrade any lowest level)' shortcut",
				"lab2": "Define Max levels of every group type at which shortcut 'L' will stop upgrading",
				"towers": "Towers:",
				"military": "Military:",
				"resource": "Resource:",
				"cottage": "Cottage:",
				"barracks": "Barracks:",
				"utilities": "Utilities:"
			},
			"opts_set_hotkeys": "Click on one of the following buttons and then press a key to define shortcut",
			"opts_hotkey_labels": {
				"lab1": "Build hotkeys:",
				"lab2": "Upgrade hotkeys:",
				"lab3": "Moonstone creation hotkeys:",
				"lab4": "Global hotkeys:",
				"upgrade": "Upgrade building",
				"downgrade": "Downgrade / Demolish (Shift+)",
				"minister": "Assign to Minister",
				"prev_city": "Previous city",
				"next_city": "Next city"
			},
			"opts_clr_inc_res": "Incoming resources label font colors:",
			"opts_clr_chat": {
				"lab": "Chat font colors:",
				"all": "All:",
				"alliance": "Alliance:",
				"whisper": "Whisper ",
				"background": "Background:",
				"social": "Social:",
				"louwin": "LoU:"
			},
			"opts": {
				"save": "Save",
				"export": "Export",
				"import": "Import",
				"export_lab": "You can save this string in a text file and import it later when needed.",
				"import_lab": "Insert saved LoU Tweak Options into text field and press OK.",
				"import_invalid": "Inserted string is invalid"
			},
			"layout": {
				"city": "City layout",
				"overlay": "Overlay layout",
				"apply": "Apply layout",
				"remove": "Remove layout"
			},
			"opts_lang": {
				"lab": "LoU Tweak language",
				"en": "English (Englisch)",
				"de": "German (Deutsch)",
				"es": "Spanish (Español)",
				"pl": "Polish (Polski)",
				"pt": "Portuguese (Português)",
				"ru": "Russian (Русский)",
				"it": "Italian (Italiano)",
				"fr": "French (Français)"
			},
			"purify_btn_tt": "Click to open 'Purify resources' window",
			"opts_minimap": {
				"enable_lab": "Enable MiniMap",
				"clrs_lab": "MiniMap colors:",
				"show_cities": "Show cities",
				"show_none": "None",
				"show_noncastle": "Non-castle",
				"show_castle": "Castle",
				"show_all": "All",
				"show_self": "My",
				"show_alliance": "Alliance",
				"show_allied": "Allied",
				"show_enemy": "Enemy",
				"show_nap": "NAP",
				"show_other": "Other",
				"show_lawless": "Lawless",
				"show_moongate": "Moongates",
				"show_shrine": "Shrines",
				"clr_self": "Self:",
				"clr_alliance": "Alliance:",
				"clr_allied": "Allied:",
				"clr_enemy": "Enemy:",
				"clr_nap": "NAP:",
				"clr_other": "Other:",
				"clr_lawless": "Lawless:",
				"clr_moongate": "Moongate:",
				"clr_shrine": "Shrine:"
			},
			"trade_limit": "Limit",
			"no": "No",
			"yes": "Yes",
			"req_restart": "(requires restart)",
			"opts_save_ss_cn": "Save overlay layout Sharestring in city notes",
			"opts_trade_lab_max_amount": "Amount of Trade Summary labels to be displayed:",
			"show_get_use_btn_tt": "Show 'Get & Use' buttons",
			"opts_hide_get_use": "Hide 'Get & Use' buttons",
			"btn_trade_show": "Show Trade Summary labels",
			"btn_trade_hide": "Hide Trade Summary labels",
			"btn_support_show": "Show Support labels",
			"btn_support_hide": "Hide Support labels",
			"copy_to_chat": "Copy Share report ID to chat"
		},
		"1": { /* german */
			"options_btn_tt": "LoU Tweak Optionen anzeigen",
			"layout_btn_tt": "Für die aktuelle Stadt einen LoU City Planner Sharestring erzeugen",
			"chat_btn_city": "Stadt",
			"chat_btn_player": "Spieler",
			"chat_btn_alliance": "Allianz",
			"chat_btn_url": "Link",
			"copy_coords_btn": "Kopiere Koordinaten in den Chat",
			"up_count_tt": "Zum Aufwerten verfügbare Gebäude:",
			"opts_max_chatlines": "Maximale Zeilen im Chat:",
			"opts_chat_opacity": "Chat Hintergrundtransparenz:",
			"opts_switch_to_ally_tab": "Beim Start zum  Allianz-Tab wechseln",
			"opts_show_queue_win": "Info-Fenster für Aufträge anzeigen",
			"opts_limit_req_res": "Begrenze bestellte Rohstoffe auf die freie Lagerkapazität der Stadt",
			"opts_inc_res": {
				"lab": "Label für ankommende Waren:",
				"disabled": "deaktiviert",
				"always": "Immer an",
				"context": "Kontextabhängig"
			},
			"opts_separator": {
				"lab": "Tausendertrennung:",
				"period": "'.' (Punkt)",
				"comma": "',' (Komma)",
				"space": "' ' (Leerzeichen)",
				"none": "ohne"
			},
			"opts_city_tag": {
				"lab": "[stadt] Tag zeigt:",
				"info": "Stadt Info",
				"region": "Regionsansicht"
			},
			"opts_lowest_lvl": {
				"lab1": "Wähle die Gebäude zur Aufwertung durch den 'L (niedrigste Stufe aufwerten)' Tastenkürzel aus",
				"lab2": "Die maximale Stufe für jede Gruppe festlegen, bei der das Tastenkürzel 'L' das Aufwerten beendet",
				"towers": "Türme:",
				"military": "Militär:",
				"resource": "Waren:",
				"cottage": "Wohnhaus:",
				"barracks": "Kaserne:",
				"utilities": "Versorger:"
			},
			"opts_set_hotkeys": "Zum Festlegen eines Tastenkürzels zuerst den Button anklicken und dann eine Taste drücken",
			"opts_hotkey_labels": {
				"lab1": "Aufbau-Hotkeys:",
				"lab2": "Aufwertungs-Hotkeys:",
				"lab3": "Mondsteinerzeugungs-Hotkeys:",
				"lab4": "Allgemeine Hotkeys:",
				"upgrade": "Gebäude aufwerten",
				"downgrade": "Abwerten / Abriss (Umschalt+)",
				"minister": "Dem Minister zuweisen",
				"prev_city": "Vorherige Stadt",
				"next_city": "Nächste Stadt"
			},
			"opts_clr_inc_res": "Font Farbe für Ankommende Waren Label:",
			"opts_clr_chat": {
				"lab": "Font Farben für Chat:",
				"all": "Alle:",
				"alliance": "Allianz:",
				"whisper": "Flüstern ",
				"background": "Hintergrund:",
				"social": "Social:",
				"louwin": "LoU:"
			},
			"opts": {
				"save": "Speichern",
				"export": "Exportieren",
				"import": "Importieren",
				"export_lab": "Diese Zeichenkette in einer Textdatei speichern und später bei Bedarf importieren.",
				"import_lab": "Gespeicherte LoU Tweak Optionen in das Textfeld einfügen und OK drücken.",
				"import_invalid": "Die eingefügte Zeichenkette ist ungültig"
			},
			"layout": {
				"city": "Stadtplan",
				"overlay": "Übersichtsplan einblenden",
				"apply": "Übersichtsplan anwenden",
				"remove": "Übersichtsplan entfernen"
			},
			"opts_lang": {
				"lab": "Sprache des LoU Tweak",
				"en": "Englisch (English)",
				"de": "Deutsch (German)",
				"es": "Spanisch (Spanish)",
				"pl": "Polnisch (Polish)",
				"pt": "Portuguese (Portuguese)",
				"ru": "Russian (Русский)",
				"it": "Italian (Italiano)",
				"fr": "French (Français)"
			},
			"purify_btn_tt": "Click to open 'Purify resources' window",
			"opts_minimap": {
				"enable_lab": "Enable MiniMap",
				"clrs_lab": "MiniMap colors:",
				"show_cities": "Show cities",
				"show_none": "None",
				"show_noncastle": "Non-castle",
				"show_castle": "Castle",
				"show_all": "All",
				"show_self": "My",
				"show_alliance": "Alliance",
				"show_allied": "Allied",
				"show_enemy": "Enemy",
				"show_nap": "NAP",
				"show_other": "Other",
				"show_lawless": "Lawless",
				"show_moongate": "Moongates",
				"show_shrine": "Shrines",
				"clr_self": "Self:",
				"clr_alliance": "Alliance:",
				"clr_allied": "Allied:",
				"clr_enemy": "Enemy:",
				"clr_nap": "NAP:",
				"clr_other": "Other:",
				"clr_lawless": "Lawless:",
				"clr_moongate": "Moongate:",
				"clr_shrine": "Shrine:"
			},
			"trade_limit": "Limit",
			"no": "No",
			"yes": "Yes",
			"req_restart": "(requires restart)",
			"opts_save_ss_cn": "Save overlay layout Sharestring in city notes",
			"opts_trade_lab_max_amount": "Amount of Trade Summary labels to be displayed:",
			"show_get_use_btn_tt": "Show 'Get & Use' buttons",
			"opts_hide_get_use": "Hide 'Get & Use' buttons",
			"btn_trade_show": "Show Trade Summary labels",
			"btn_trade_hide": "Hide Trade Summary labels",
			"btn_support_show": "Show Support labels",
			"btn_support_hide": "Hide Support labels",
			"copy_to_chat": "Copy Share report ID to chat"
		},
		"2": { /* spanish */
			"options_btn_tt": "Pincha para mostrar las opciones de LoU Tweak",
			"layout_btn_tt": "Pincha para generar un texto con el diseño de tu ciudad actual",
			"chat_btn_city": "Ciudad",
			"chat_btn_player": "Jugador",
			"chat_btn_alliance": "Alianza",
			"chat_btn_url": "Link",
			"copy_coords_btn": "Copiar coordenadas al chat",
			"up_cout_tt": "Edificios disponibles para ampliar:",
			"opts_max_chatlines": "Líneas máximas de chat:",
			"opts_chat_opacity": "Transparencia de la ventana de Chat:",
			"opts_switch_to_ally_tab": "Cambiar a la pestaña Alianza al comenzar",
			"opts_show_queue_win": "Mostrar ventana de información de colas",
			"opts_limit_req_res": "Limitar recursos solicitados a la capacidad disponible de la ciudad",
			"opts_inc_res": {
				"lab": "Etiqueta de recursos entrates:",
				"disabled": "Desactivado",
				"always": "Siempre",
				"context": "Contextual"
			},
			"opts_separator": {
				"lab": "Separador de miles:",
				"period": "'.' (punto)",
				"comma": "',' (coma)",
				"space": "' ' (espacio)",
				"none": "ninguno"
			},
			"opts_city_tag": {
				"lab": "La etiqueta [city] muestra:",
				"info": "Información de la ciudad",
				"region": "Vista de la región"
			},
			"opts_lowest_lvl": {
				"lab1": "Selecciona los edificios que quieres ampliar con el acceso directo 'L (amplia cualquiera del nivel más bajo)'",
				"lab2": "Define el nivel máximo de todos los tipos de grupo con el que el acceso directo 'L' se detendrá la actualización",
				"towers": "Torres:",
				"military": "Militares:",
				"resource": "Recursos:",
				"cottage": "Cottage:",
				"barracks": "Barracas:",
				"utilities": "Utilidades:"
			},
			"opts_set_hotkeys": "Pincha en uno de los siguientes botones y presiona una tecla para definir un acceso directo",
			"opts_hotkey_labels": {
				"lab1": "Teclas de acceso directo para Edificios:",
				"lab2": "Teclas de acceso directo para Ampliaciones:",
				"lab3": "Teclas de acceso directo para la creación de Moonstone:",
				"lab4": "Teclas de acceso directo Globales:",
				"upgrade": "Ampliar edificios",
				"downgrade": "Desampliar / Demoler (Shift+)",
				"minister": "Asignar al Ministro",
				"prev_city": "Ciudad anterior",
				"next_city": "Ciudad siguiente"
			},
			"opts_clr_inc_res": "Color de las fuente de la etiqueta de recursos entrantes:",
			"opts_clr_chat": {
				"lab": "Color de la fuente del Chat:",
				"all": "Todos:",
				"alliance": "Alianza:",
				"whisper": "Susurro ",
				"background": "Fondo:",
				"social": "Social:",
				"louwin": "LoU:"
			},
			"opts": {
				"save": "Salvar",
				"export": "Exportar",
				"import": "Importar",
				"export_lab": "Puedes salvar esta cadena de texto como un fichero de texto e importarlo más adelante.",
				"import_lab": "Inserta las opciones salvadas del LoU Tweak en el campo de texto y presiona ok.",
				"import_invalid": "La cadena de texto introducida no es válida"
			},
			"layout": {
				"city": "Diseño de la ciudad",
				"overlay": "Superponer diseño",
				"apply": "Aplicar diseño",
				"remove": "Eliminar diseño"
			},
			"opts_lang": {
				"lab": "Idoma:",
				"en": "Inglés (English)",
				"de": "Alemán (Deutsch)",
				"es": "Español (Spanish)",
				"pl": "Polaco (Polish)",
				"pt": "Portuguese (Portuguese)",
				"ru": "Russian (Русский)",
				"it": "Italian (Italiano)",
				"fr": "French (Français)"
			},
			"purify_btn_tt": "Pincha aquí para abrir la ventana 'Purificación de recursos'",
			"opts_minimap": {
				"enable_lab": "Activar MiniMapa",
				"clrs_lab": "Colores del MiniMapa:",
				"show_cities": "Mostrar ciudades",
				"show_none": "Ninguno",
				"show_noncastle": "Sin castillo",
				"show_castle": "Castillo",
				"show_all": "Todo",
				"show_self": "Yo",
				"show_alliance": "Alianza",
				"show_allied": "Aliado",
				"show_enemy": "Enemigo",
				"show_nap": "NAP",
				"show_other": "Otro",
				"show_lawless": "Lawless",
				"show_moongate": "Moongates",
				"show_shrine": "Shrines",
				"clr_self": "Yo:",
				"clr_alliance": "Alianza:",
				"clr_allied": "Aliado:",
				"clr_enemy": "Enemigo:",
				"clr_nap": "NAP:",
				"clr_other": "Otro:",
				"clr_lawless": "Lawless:",
				"clr_moongate": "Moongate:",
				"clr_shrine": "Shrine:"
			},
			"trade_limit": "Límite",
			"no": "No",
			"yes": "Si",
			"req_restart": "(requiere reiniciar)",
			"opts_save_ss_cn": "Save overlay layout Sharestring in city notes",
			"opts_trade_lab_max_amount": "Amount of Trade Summary labels to be displayed:",
			"show_get_use_btn_tt": "Show 'Get & Use' buttons",
			"opts_hide_get_use": "Hide 'Get & Use' buttons",
			"btn_trade_show": "Show Trade Summary labels",
			"btn_trade_hide": "Hide Trade Summary labels",
			"btn_support_show": "Show Support labels",
			"btn_support_hide": "Hide Support labels",
			"copy_to_chat": "Copy Share report ID to chat"
		},
		"3": { /* polish */
			"options_btn_tt": "Kliknij aby otworzyć okno opcji LoU Tweak",
			"layout_btn_tt": "Kliknij aby wygenerować plan (ShareString) tego miasta",
			"chat_btn_city": "Miasto",
			"chat_btn_player": "Gracz",
			"chat_btn_alliance": "Sojusz",
			"chat_btn_url": "Link",
			"copy_coords_btn": "Kopiuj współrzędne do czatu",
			"up_count_tt": "Ilość budynków możliwych do rozbudowy:",
			"opts_max_chatlines": "Maksymalna liczba linii czatu:",
			"opts_chat_opacity": "Przezroczystość tła czatu:",
			"opts_switch_to_ally_tab": "Przełącz na kartę Sojuszu podczas startu",
			"opts_show_queue_win": "Pokaż okno z czasami kolejek",
			"opts_limit_req_res": "Ogranicz zamawiane surowce do wolnego miejsca",
			"opts_inc_res": {
				"lab": "Okno przybywających surowców:",
				"disabled": "Wyłączone",
				"always": "Zawsze włączone",
				"context": "Kontekstowo"
			},
			"opts_separator": {
				"lab": "Separator tysięczny:",
				"period": "'.' (kropka)",
				"comma": "',' (przecinek)",
				"space": "' ' (spacja)",
				"none": "brak"
			},
			"opts_city_tag": {
				"lab": "Tag [city] pokazuje:",
				"info": "Informacje o mieście",
				"region": "Widok regionu"
			},
			"opts_lowest_lvl": {
				"lab1": "Wybierz budynki, które chcesz rozbudować przy pomocy skrótu 'L (rozbuduj najniższy poziom)'",
				"lab2": "Zdefinuj poziomy dla każdej grupy, przy których skrót 'L' przestanie ulepszać",
				"towers": "Wieże:",
				"military": "Wojskowe:",
				"resource": "Surowce:",
				"cottage": "Chatki:",
				"barracks": "Baraki:",
				"utilities": "Użyteczności:"
			},
			"opts_set_hotkeys": "Aby przypisać skrót, kliknij na przycisku, a następnie wciśnij klawisz na klawiaturze",
			"opts_hotkey_labels": {
				"lab1": "Skróty konstrukcyjne:",
				"lab2": "Skróty ulepszeń:",
				"lab3": "",
				"lab4": "Skróty globalne:",
				"upgrade": "Rozbuduj budynek",
				"downgrade": "Degraduj / Zniszcz (Shift+)",
				"minister": "Przypisz do Ministra",
				"prev_city": "Poprzednie miasto",
				"next_city": "Następne miasto"
			},
			"opts_clr_inc_res": "Kolory okna przybywających surowców:",
			"opts_clr_chat": {
				"lab": "Kolory czatu:",
				"all": "Wszyscy:",
				"alliance": "Sojusz:",
				"whisper": "Szept ",
				"background": "Tło:",
				"social": "Social:",
				"louwin": "LoU:"
			},
			"opts": {
				"save": "Zapisz",
				"export": "Eksport",
				"import": "Import",
				"export_lab": "Możesz zapisać ten tekst w pliku tekstowym i w razie potrzeby przywrócić opcje.",
				"import_lab": "Wklej zapisane opcje LoU Tweak i wciśnij OK.",
				"import_invalid": "Wklejony ciąg jest niepoprawny"
			},
			"layout": {
				"city": "Plan miasta",
				"overlay": "Wirtualny plan",
				"apply": "Zastosuj plan",
				"remove": "Usuń plan"
			},
			"opts_lang": {
				"lab": "Język LoU Tweak",
				"en": "Angielski (English)",
				"de": "Niemiecki (German)",
				"es": "Hiszpański (Spanish)",
				"pl": "Polski (Polish)",
				"pt": "Portugalski (Português)",
				"ru": "Rosyjski (Русский)",
				"it": "Włoski (Italiano)",
				"fr": "Francuski (French)"
			},
			"purify_btn_tt": "Kliknij aby otworzyć okno oczyszczania surowców",
			"opts_minimap": {
				"enable_lab": "Włącz MiniMapę",
				"clrs_lab": "Kolory MiniMapy:",
				"show_cities": "Pokaż miasta",
				"show_none": "Żadne",
				"show_noncastle": "Bez zamku",
				"show_castle": "Z zamkiem",
				"show_all": "Wszystkie",
				"show_self": "Moje",
				"show_alliance": "Sojuszu",
				"show_allied": "Sprzymierzone",
				"show_enemy": "Wrogów",
				"show_nap": "NAP",
				"show_other": "Inne",
				"show_lawless": "Porzucone",
				"show_moongate": "Moongates",
				"show_shrine": "Shrines",
				"clr_self": "Moje:",
				"clr_alliance": "Sojusz:",
				"clr_allied": "Sprzymierzone:",
				"clr_enemy": "Wrogie:",
				"clr_nap": "NAP:",
				"clr_other": "Inne:",
				"clr_lawless": "Porzucone:",
				"clr_moongate": "Moongate:",
				"clr_shrine": "Shrine:"
			},
			"trade_limit": "Limit",
			"no": "Nie",
			"yes": "Tak",
			"req_restart": "(wymagany restart)",
			"opts_save_ss_cn": "Zapisz plan miasta w notatkach",
			"opts_trade_lab_max_amount": "Amount of Trade Summary labels to be displayed:",
			"show_get_use_btn_tt": "Show 'Get & Use' buttons",
			"opts_hide_get_use": "Hide 'Get & Use' buttons",
			"btn_trade_show": "Show Trade Summary labels",
			"btn_trade_hide": "Hide Trade Summary labels",
			"btn_support_show": "Show Support labels",
			"btn_support_hide": "Hide Support labels",
			"copy_to_chat": "Copy Share report ID to chat"
		},
		"4": { /* portuguese */
			"options_btn_tt": "Clique para mostrar as opções do LoU Tweak",
			"layout_btn_tt": "Clique para gerar a Sharestring da cidade atual",
			"chat_btn_city": "Cidade",
			"chat_btn_player": "Jogador",
			"chat_btn_alliance": "Aliança",
			"chat_btn_url": "Link",
			"copy_coords_btn": "Copiar as coordenadas para o bate-papo",
			"up_count_tt": "Construções disponíveis para melhora:",
			"opts_max_chatlines": "Máximo de linhas no bate-papo:",
			"opts_chat_opacity": "Transparência do fundo do bate-papo:",
			"opts_switch_to_ally_tab": "Mostrar a guia Aliança ao iniciar",
			"opts_show_queue_win": "Mostrar janela de informações da fila",
			"opts_limit_req_res": "Limitar os recursos pedidos ao espaço livre da cidade",
			"opts_inc_res": {
				"lab": "Rótulo dos recursos a chegar:",
				"disabled": "Desabilitado",
				"always": "Sempre ligado",
				"context": "Contextual"
			},
			"opts_separator": {
				"lab": "Separador de milhares:",
				"period": "'.' (ponto)",
				"comma": "',' (vírgula)",
				"space": "' ' (espaço)",
				"none": "nenhum"
			},
			"opts_city_tag": {
				"lab": "A marca [city] mostra:",
				"info": "Informações da cidade",
				"region": "Vista da região"
			},
			"opts_lowest_lvl": {
				"lab1": "Selecione as construções que você quer melhor com o atalho 'L (melhorar o de menor nível)'",
				"lab2": "Defina o nível máximo ao qual o atalho 'L' irá parar de melhorar",
				"towers": "Torres:",
				"military": "Militar:",
				"resource": "Recursos:",
				"cottage": "Casas pequenas:",
				"barracks": "Casernas:",
				"utilities": "Utilitários:"
			},
			"opts_set_hotkeys": "Clique em um dos seguintes botões e aperte uma tecla para definir o atalho",
			"opts_hotkey_labels": {
				"lab1": "Atalhos para construção:",
				"lab2": "Atalhos para melhora:",
				"lab3": "Artalhos para criação de Pedra do Luar:",
				"lab4": "Atalhos globais:",
				"upgrade": "Melhorar construção",
				"downgrade": "Reduzir nível / Demolir (Shift+)",
				"minister": "Atribuir ao ministro",
				"prev_city": "Cidade anterior",
				"next_city": "Próxima cidade"
			},
			"opts_clr_inc_res": "Cores dos rótulos dos recursos a chegar:",
			"opts_clr_chat": {
				"lab": "Cores do texto do bate-papo:",
				"all": "Todos:",
				"alliance": "Aliança:",
				"whisper": "Sussurrar ",
				"background": "Cor do fundo:",
				"social": "Social:",
				"louwin": "LoU:"
			},
			"opts": {
				"save": "Salvar",
				"export": "Exportar",
				"import": "Importar",
				"export_lab": "Você pode salvar isto em um arquivo de texto e importar mais tarde quando necessário.",
				"import_lab": "Insira as opções salvas do LoU Tweak no campo de texto e aperte OK.",
				"import_invalid": "O texto inserido é inválido"
			},
			"layout": {
				"city": "Projeto da cidade",
				"overlay": "Sobrepor projeto",
				"apply": "Aplicar projeto",
				"remove": "Remover projeto"
			},
			"opts_lang": {
				"lab": "Idioma do LoU Tweak",
				"en": "Inglês (Englisch)",
				"de": "Alemão (Deutsch)",
				"es": "Espanhol (Español)",
				"pl": "Polonês (Polski)",
				"pt": "Português (Portuguese)",
				"ru": "Russian (Русский)",
				"it": "Italian (Italiano)",
				"fr": "French (Français)"
			},
			"purify_btn_tt": "Clique para abrir a janela 'Purificar Recursos'",
			"opts_minimap": {
				"enable_lab": "Habilitar Minimapa",
				"clrs_lab": "Cores do Minimapa:",
				"show_cities": "Mostrar cidades",
				"show_none": "Nenhuma",
				"show_noncastle": "Sem castelo",
				"show_castle": "Com castelo",
				"show_all": "Todas",
				"show_self": "Minhas",
				"show_alliance": "Aliança",
				"show_allied": "Aliados",
				"show_enemy": "Inimigos",
				"show_nap": "PNA",
				"show_other": "Outras",
				"show_lawless": "Cidades sem lei",
				"show_moongate": "Portas do Luar",
				"show_shrine": "Palácios",
				"clr_self": "Próprias:",
				"clr_alliance": "Aliança:",
				"clr_allied": "Aliados:",
				"clr_enemy": "Inimigos:",
				"clr_nap": "PNA:",
				"clr_other": "Outras:",
				"clr_lawless": "Cidades sem lei:",
				"clr_moongate": "Portas do Luar:",
				"clr_shrine": "Palácios:"
			},
			"trade_limit": "Limite",
			"no": "Não",
			"yes": "Sim",
			"req_restart": "(requer reinício)",
			"opts_save_ss_cn": "Salvar a Sharestring do projeto sobreposto nas Notas da Cidade",
			"opts_trade_lab_max_amount": "Quantide de rótulos a mostrar no Resumo do Comércio:",
			"show_get_use_btn_tt": "Mostrar botões 'Obter e usar'",
			"opts_hide_get_use": "Ocultar botões 'Obter e usar'",
			"btn_trade_show": "Show Trade Summary labels",
			"btn_trade_hide": "Hide Trade Summary labels",
			"btn_support_show": "Show Support labels",
			"btn_support_hide": "Hide Support labels",
			"copy_to_chat": "Copy Share report ID to chat"
		},
		"5": { /* russian */
			"options_btn_tt": "Нажмите для показа настроек LoU Tweak",
			"layout_btn_tt": "Нажмите для создания макета Sharestring для этого города",
			"chat_btn_city": "Город",
			"chat_btn_player": "Игрок",
			"chat_btn_alliance": "Альянс",
			"chat_btn_url": "Ссылка",
			"copy_coords_btn": "Координаты в чат",
			"up_count_tt": "Здания, доступные для повышения уровня:",
			"opts_max_chatlines": "Максимум строк в чате:",
			"opts_chat_opacity": "Прозрачность фона чата:",
			"opts_switch_to_ally_tab": "Перейти во вкладку альянса при запуске",
			"opts_show_queue_win": "Показывать очередь в окне информации",
			"opts_limit_req_res": "Установить лимит запрашиваемых ресурсов исходя из свободного места в городе",
			"opts_inc_res": {
				"lab": "Показ информации о поступающих ресурсах:",
				"disabled": "Отключить",
				"always": "Всегда",
				"context": "Если поступают"
			},
			"opts_separator": {
				"lab": "Разделять тысячи:",
				"period": "'.' (точкой)",
				"comma": "',' (запятой)",
				"space": "' ' (пробелом)",
				"none": "не разделять"
			},
			"opts_city_tag": {
				"lab": "тэг [city] показывает:",
				"info": "Информацию о городе",
				"region": "Место в регионе"
			},
			"opts_lowest_lvl": {
				"lab1": "Выберите здания, которым вы хотите повысить уровень с горячей клавишей 'L (Повышение уровня любого низкого уровня)'",
				"lab2": "Определить максимальный уровень повышения каждой группы для горячей клавиши 'L'",
				"towers": "Башни:",
				"military": "Военные:",
				"resource": "Ресурсные:",
				"cottage": "Коттеджи:",
				"barracks": "Казармы:",
				"utilities": "Обслуживающие:"
			},
			"opts_set_hotkeys": "Нажмите на одну из следующих кнопок и затем нажмите на клавишу, для определения горячей клавиши",
			"opts_hotkey_labels": {
				"lab1": "Горячие клавишит зданий:",
				"lab2": "Горячие клавиши повышения уровня:",
				"lab3": "Горячие клавиши обогащения ресурсов:",
				"lab4": "Глобальные горячие клавиши:",
				"upgrade": "Повышение уровня здания",
				"downgrade": "Понижение уровня / Снос (Shift+)",
				"minister": "Назначить министра",
				"prev_city": "Предыдущий город",
				"next_city": "Следующий город"
			},
			"opts_clr_inc_res": "Цвет шрифта окна поступающих ресурсов:",
			"opts_clr_chat": {
				"lab": "Цвет шрифта чата:",
				"all": "Все:",
				"alliance": "Альянс:",
				"whisper": "Личные сообщения ",
				"background": "Фон:",
				"social": "Social:",
				"louwin": "LoU:"
			},
			"opts": {
				"save": "Сохранить",
				"export": "Экспорт",
				"import": "Импорт",
				"export_lab": "Вы можете сохранить эти строки в текстовый файл и импортировать когда понадобится.",
				"import_lab": "Вставьте сохраненные настройки LoU Tweak в текстовое поле и нажмите OK.",
				"import_invalid": "Вставленная строка не подходит"
			},
			"layout": {
				"city": "План города",
				"overlay": "Наложение плана",
				"apply": "Применить план",
				"remove": "Удалить план"
			},
			"opts_lang": {
				"lab": "LoU Tweak language",
				"en": "English (Englisch)",
				"de": "German (Deutsch)",
				"es": "Spanish (Español)",
				"pl": "Polish (Polski)",
				"pt": "Portuguese (Português)",
				"ru": "Russian (Русский)",
				"it": "Italian (Italiano",
				"fr": "French (Français)"
			},
			"purify_btn_tt": "Нажмите, что бы открыть окно 'Послать ресурсы'",
			"opts_minimap": {
				"enable_lab": "Включить миникарту",
				"clrs_lab": "Цвета на миникарте:",
				"show_cities": "Показатьт города",
				"show_none": "Ничего",
				"show_noncastle": "Без замка",
				"show_castle": "Замок",
				"show_all": "Все",
				"show_self": "Мой",
				"show_alliance": "Альянс",
				"show_allied": "Союзник",
				"show_enemy": "Враг",
				"show_nap": "NAP",
				"show_other": "Другое",
				"show_lawless": "Вне закона",
				"show_moongate": "Лунные ворота",
				"show_shrine": "Святилище",
				"clr_self": "Сам:",
				"clr_alliance": "Альянс:",
				"clr_allied": "Союзник:",
				"clr_enemy": "Враг:",
				"clr_nap": "NAP:",
				"clr_other": "Другое:",
				"clr_lawless": "Нарушающий:",
				"clr_moongate": "Лунные врата:",
				"clr_shrine": "Святилище:"
			},
			"trade_limit": "Лимит",
			"no": "Нет",
			"yes": "Да",
			"req_restart": "(требуется перезагрузка)",
			"opts_save_ss_cn": "Сохранить макет Sharestring в заметках города",
			"opts_trade_lab_max_amount": "Amount of Trade Summary labels to be displayed:",
			"show_get_use_btn_tt": "Show 'Get & Use' buttons",
			"opts_hide_get_use": "Hide 'Get & Use' buttons",
			"btn_trade_show": "Show Trade Summary labels",
			"btn_trade_hide": "Hide Trade Summary labels",
			"btn_support_show": "Show Support labels",
			"btn_support_hide": "Hide Support labels",
			"copy_to_chat": "Copy Share report ID to chat"
		},
		"6": { /* italian */
			"options_btn_tt": "Clicca per mostrare le opzioni di LoU Tweak",
			"layout_btn_tt": "Clicca per creare un layout Sharestring per questa citta'",
			"chat_btn_city": "Citta'",
			"chat_btn_player": "Giocatore",
			"chat_btn_alliance": "Alleanza",
			"chat_btn_url": "Link",
			"copy_coords_btn": "Copia Coordinate nella Chat",
			"up_count_tt": "Edifici Potenziabili:",
			"opts_max_chatlines": "Numero massimo di lnee in chat:",
			"opts_chat_opacity": "Trasparenza dello sfondo nella Chat:",
			"opts_switch_to_ally_tab": "Apri la scheda Alleanza all'avvio",
			"opts_show_queue_win": "Mostra la lista della Code di Costruzione/Reclutamento",
			"opts_limit_req_res": "Impostare un limite di risorse richieste in base allo spazio disponibile in città",
			"opts_inc_res": {
				"lab": "Informazioni sulle Risorse in Arrivo:",
				"disabled": "Disabilita",
				"always": "Sempre Attiva",
				"context": "Automatica (Solo se in arrivo)"
			},
			"opts_separator": {
				"lab": "Separatore Migliaia:",
				"period": "'.' (punto)",
				"comma": "',' (virgola)",
				"space": "' ' (spazio)",
				"none": "nessuna"
			},
			"opts_city_tag": {
				"lab": "la tag [city] mostra:",
				"info": "Informazioni cità'",
				"region": "Vista Regione"
			},
			"opts_lowest_lvl": {
				"lab1": "Seleziona gli edifici che vuoi potenziare con il tasto 'L' (potenzia tutte gli edifici più bassi)",
				"lab2": "Definisci il livello massimo di poteziamento per tutti gli edifici aggiornabile con il tasto 'L'",
				"towers": "Torri:",
				"military": "Militari:",
				"resource": "Risorse:",
				"cottage": "Cottage:",
				"barracks": "Caserme:",
				"utilities": "Utilita':"
			},
			"opts_set_hotkeys": "Clicca in una dei seguenti bottoni e premi un tasto per definire la nuova scorciatoia",
			"opts_hotkey_labels": {
				"lab1": "Scorciatoie Costruzioni:",
				"lab2": "Scorciatoie Potenziamento:",
				"lab3": "Scorciatoie Risorse Purificate:",
				"lab4": "Scorciatoie Globali",
				"upgrade": "Potenzia Edificio",
				"downgrade": "Depotenzia / Demolisci (Shift+)",
				"minister": "Assegna al Ministro",
				"prev_city": "Citta' Precedente",
				"next_city": "Citta' Successiva"
			},
			"opts_clr_inc_res": "Colore scritta 'Risorse in Arrivo'",
			"opts_clr_chat": {
				"lab": "Colore del testo in Chat:",
				"all": "Tutti:",
				"alliance": "Alleanza:",
				"whisper": "Sussurro ",
				"background": "Sfondo:",
				"social": "Social:",
				"louwin": "LoU:"
			},
			"opts": {
				"save": "Salva",
				"export": "Esporta",
				"import": "Importa",
				"export_lab": "Puoi salvare questa stringa in un file di testo e importarla quando vuoi.",
				"import_lab": "Inserisci le opzioni salvate di LoU Tweak nel campo seguente e premi OK.",
				"import_invalid": "Stringa inserita non valida!"
			},
			"layout": {
				"city": "City layout",
				"overlay": "Overlay layout",
				"apply": "Apply layout",
				"remove": "Remove layout"
			},
			"opts_lang": {
				"lab": "LoU Tweak language",
				"en": "English (Englisch)",
				"de": "German (Deutsch)",
				"es": "Spanish (Español)",
				"pl": "Polish (Polski)",
				"pt": "Portuguese (Português)",
				"ru": "Russian (Русский)",
				"it": "Italian (Italiano)",
				"fr": "French (Français)"
			},
			"purify_btn_tt": "Clicca su 'Purifica Risorse' per aprire la finestra",
			"opts_minimap": {
				"enable_lab": "Abilita Mini Mappa",
				"clrs_lab": "Colori Mini Mappa:",
				"show_cities": "Mostra Citta'",
				"show_none": "Nessuna",
				"show_noncastle": "Senza Castello",
				"show_castle": "Castlelli",
				"show_all": "Tutte",
				"show_self": "Mie",
				"show_alliance": "Alleanza",
				"show_allied": "Alleate",
				"show_enemy": "Nemici",
				"show_nap": "PNA",
				"show_other": "Altre",
				"show_lawless": "Senza Legge",
				"show_moongate": "Moongates",
				"show_shrine": "Santuari",
				"clr_self": "Mie:",
				"clr_alliance": "Alleanza:",
				"clr_allied": "Alleate:",
				"clr_enemy": "Nemiche:",
				"clr_nap": "PNA:",
				"clr_other": "Altre:",
				"clr_lawless": "Senza Legge:",
				"clr_moongate": "Moongate:",
				"clr_shrine": "Santuari:"
			},
			"trade_limit": "Limiti",
			"no": "No",
			"yes": "Si",
			"req_restart": "(richiede riavvio)",
			"opts_save_ss_cn": "Salva layout Sharestring nelle note della citta'",
			"opts_trade_lab_max_amount": "Numero di etichette da mostrare per il commercio:",
			"show_get_use_btn_tt": "Mostra i pulsanti 'Compra & Usa'",
			"opts_hide_get_use": "Nascondi i pulsanti 'Compra & Usa'",
			"btn_trade_show": "Show Trade Summary labels",
			"btn_trade_hide": "Hide Trade Summary labels",
			"btn_support_show": "Show Support labels",
			"btn_support_hide": "Hide Support labels",
			"copy_to_chat": "Copy Share report ID to chat"
		},
		"7": { /* french */
			"options_btn_tt": "Cliquez pour accéder aux Options de LoU Tweak",
			"layout_btn_tt": "Cliquez pour générer un 'Sharestring' pour la ville actuelle",
			"chat_btn_city": "Ville",
			"chat_btn_player": "Joueur",
			"chat_btn_alliance": "Alliance",
			"chat_btn_url": "Lien",
			"copy_coords_btn": "Copier les coordonnées dans le chat",
			"up_count_tt": "Bâtiments disponibles pour mise à niveau :",
			"opts_max_chatlines": "Lignes maximum dans le chat :",
			"opts_chat_opacity": "Transparence de l'arrière-plan du chat :",
			"opts_switch_to_ally_tab": "Aller à l'onglet Alliance au démarrage",
			"opts_show_queue_win": "Montrer la fenêtre de file d'attente",
			"opts_limit_req_res": "Limiter les ressources demandées à l'espace libre dans la ville",
			"opts_inc_res": {
				"lab": "Panneau des ressources entrantes :",
				"disabled": "Désactivé",
				"always": "Toujours actif",
				"context": "Contextuel"
			},
			"opts_separator": {
				"lab": "Séparateur de milliers :",
				"period": "'.' (point)",
				"comma": "',' (virgule)",
				"space": "' ' (espace)",
				"none": "Aucun"
			},
			"opts_city_tag": {
				"lab": "[Ville] Montrer les balises :",
				"info": "Infos de la ville",
				"region": "Vue de la région "
			},
			"opts_lowest_lvl": {
				"lab1": "Sélectionnez les bâtiments que vous souhaitez mettre à niveau avec 'L' (mise à niveau des plus bas niveau) ",
				"lab2": "Définissez les niveaux maximum de chaque type de groupe auquel 'L' doit arrêter la mise à niveau",
				"towers": "Tours :",
				"military": "Militaire :",
				"resource": "Ressources :",
				"cottage": "Cottages :",
				"barracks": "Casernes :",
				"utilities": "Utilitaires :"
			},
			"opts_set_hotkeys": "Cliquez sur un des boutons suivants, puis appuyez sur une touche pour définir des raccourcis",
			"opts_hotkey_labels": {
				"lab1": "Raccourci Construire :",
				"lab2": "Raccourci Monter de niveau :",
				"lab3": "Raccourci Création de pierre lunaire :",
				"lab4": "Raccourci Globaux :",
				"upgrade": "Monter niveau bâtiment",
				"downgrade": "Baisser niveau / DDémolir (Shift+)",
				"minister": "Assigner au Ministre",
				"prev_city": "Ville précédente",
				"next_city": "Ville suivante"
			},
			"opts_clr_inc_res": "Coleurs pour les ressources entrantes :",
			"opts_clr_chat": {
				"lab": "Couleurs pour le chat :",
				"all": "Tous :",
				"alliance": "Alliance :",
				"whisper": "Murmurer :",
				"background": "Arrière-plan :",
				"social": "Social :",
				"louwin": "LoU :"
			},
			"opts": {
				"save": "Sauver",
				"export": "Exporter",
				"import": "Importer",
				"export_lab": "Vous pouvez enregistrer cette chaîne dans un fichier texte et l'importer plus tard, lorsque cela est nécessaire.",
				"import_lab": "Insérez les données sauvées de LoU Tweak Options dans le champ texte et appuyez sur OK.",
				"import_invalid": "La chaîne insérée est invalide"
			},
			"layout": {
				"city": "Masque de la ville",
				"overlay": "Supperposer masque",
				"apply": "Appliquer masque",
				"remove": "Enlever masque"
			},
			"opts_lang": {
				"lab": "LoU Tweak language",
				"en": "English (Englisch)",
				"de": "German (Deutsch)",
				"es": "Spanish (Español)",
				"pl": "Polish (Polski)",
				"pt": "Portuguese (Português)",
				"ru": "Russian (Русский)",
				"it": "Italian (Italiano)",
				"fr": "French (Français)"
			},
			"purify_btn_tt": "Cliquez ici pour ouvrir la fenêtre 'Purifier des ressources'",
			"opts_minimap": {
				"enable_lab": "Activer la MiniMap",
				"clrs_lab": "Couleurs de la MiniMap :",
				"show_cities": "Montrer les villes",
				"show_none": "Rien",
				"show_noncastle": "Sans château",
				"show_castle": "Avec château",
				"show_all": "Tout",
				"show_self": "Moi",
				"show_alliance": "Alliance",
				"show_allied": "Alliés",
				"show_enemy": "Ennemis",
				"show_nap": "NAP",
				"show_other": "Autre ",
				"show_lawless": "Sans foi ni loi",
				"show_moongate": "Portes lunaires",
				"show_shrine": "Sanctuaires",
				"clr_self": "Self:",
				"clr_alliance": "Alliance :",
				"clr_allied": "Alliés :",
				"clr_enemy": "Ennemis :",
				"clr_nap": "NAP :",
				"clr_other": "Autres :",
				"clr_lawless": "Sans foi ni loi :",
				"clr_moongate": "Portes lunaires :",
				"clr_shrine": "Sanctuaires:"
			},
			"trade_limit": "Limite",
			"no": "Non",
			"yes": "Oui",
			"req_restart": "(Redémarrage nécessaire)",
			"opts_save_ss_cn": "Enregistrer la superposition des masques Sharestring dans les notes de la ville",
			"opts_trade_lab_max_amount": "Nombre d'opérations de commerce à afficher :",
			"show_get_use_btn_tt": "Montrer les boutons 'Avoir & Utiliser'",
			"opts_hide_get_use": "Cacher les boutons 'Avoir & Utiliser'",
			"btn_trade_show": "Show Trade Summary labels",
			"btn_trade_hide": "Hide Trade Summary labels",
			"btn_support_show": "Show Support labels",
			"btn_support_hide": "Hide Support labels",
			"copy_to_chat": "Copy Share report ID to chat"
			}
		};
});
