loader.addFinishHandler(function () {

    qx.Class.define("paTweak.CoordUtils", {
        type: "singleton",
        extend: qx.core.Object,
        statics: {
            convertCoordinatesToId: function (x, y) {
                var id = parseInt(x, 10) | (parseInt(y, 10) << 16);
                return id;
            },
            convertIdToCoodrinates: function (id) {
                var o = this.convertIdToCoordinatesObject(id);
                return o.xPos + ":" + o.yPos;
            },
            convertIdToCoordinatesObject: function (id) {
                var o = {
                    xPos: (id & 0xFFFF),
                    yPos: (id >> 16),
                }
                o.cont = webfrontend.data.Server.getInstance().getContinentFromCoords(o.xPos, o.yPos);
                return o;
            }
        }
    });
});
