loader.addFinishHandler(function () {

    qx.Class.define("paTweak.ui.PlayerReportsWindow", {
        type: "singleton",
        extend: qx.ui.window.Window,
        construct: function () {
            this.base(arguments, 'Scouting Reports');
            this.buildUI();
        },
        members: {
            _wcpText: null,
            _wcText: null,
            _wcText1: null,
            cityArray: null,

            buildUI: function () {
                var app = qx.core.Init.getApplication();

                this.setLayout(new qx.ui.layout.VBox(10));
                this.set({ allowMaximize: false, allowMinimize: false, showMaximize: false, showMinimize: false,
                    showStatusbar: false, showClose: false, contentPadding: 5, useMoveFrame: true, resizable: true
                });
                this.setWidth(400);
                webfrontend.gui.Util.formatWinClose(this);

                var wcLabel = new qx.ui.basic.Label("Scouting Reports").set({ font: "bold" });
                this.add(wcLabel);

                this._wcpText = new qx.ui.form.TextArea();
                this._wcpText.set({ readOnly: true, allowGrowY: false, autoSize: false, tabIndex: 302, height: 30 });
                app.setElementModalInput(this._wcpText);
                this._wcpText.setValue("");
                this.add(this._wcpText);
                wcpTextBox = this._wcpText;

                wcLabel = new qx.ui.basic.Label("BOS Tools Intelligence Format").set({ font: "bold" });
                this.add(wcLabel);

                this._wcText = new qx.ui.form.TextArea();
                this._wcText.set({ readOnly: true, allowGrowY: false, autoSize: false, tabIndex: 303, height: 150 });
                app.setElementModalInput(this._wcText);
                this._wcText.setValue("");
                this.add(this._wcText);
                wcTextBox = this._wcText;

                wcLabel = new qx.ui.basic.Label("MERC Format").set({ font: "bold" });
                this.add(wcLabel);

                this._wcText1 = new qx.ui.form.TextArea();
                this._wcText1.set({ readOnly: true, allowGrowY: false, autoSize: false, tabIndex: 303, height: 150 });
                app.setElementModalInput(this._wcText1);
                this._wcText1.setValue("");
                this.add(this._wcText1);
                wcTextBox1 = this._wcText1;

                var row = new qx.ui.container.Composite(new qx.ui.layout.HBox(2));

                var label = new qx.ui.basic.Label("Number of days to get");
                label.set({font: "bold"});
                row.add(label, {left: 13, top: 8});

                this._numDays = new qx.ui.form.TextField();
                this._numDays.set({toolTipText: "Number of days to get"});
                app.setElementModalInput(this._numDays);
                this._numDays.setValue("1");
                row.add(this._numDays);
                numDays = "1";
                this._numDays.addListener("changeValue", this.setNumDays, this);

                // go button
                var goButton = new qx.ui.form.Button("Go");
                goButton.addListener("execute", this.getplayerReports, this);
                row.add(goButton);

                // Close button
                var closeButton = new qx.ui.form.Button("Close");
                closeButton.addListener("execute", this.hide, this);
                row.add(closeButton);

                this.add(row);

                myAllianceName = webfrontend.data.Alliance.getInstance().getName().toLowerCase();
            },
            setNumDays: function (e) {
                numDays = this._numDays.getValue();
            },
            getplayerReports: function () {
                playerGetRange = new Array();
                this.cityArray = new Array();
                server = webfrontend.data.Server.getInstance();
                playerIds = new Array();
                cityIds = new Array();
                cities = new Array();
                cityArray = new Array();
                reportIds = new Array();
                playerIx = 0;
                reportIx = 0;
                cityIx = 0;
                reportIx = 0;
                reportIds = new Array();
                commandManager = webfrontend.net.CommandManager.getInstance();
                this._wcText.setValue("[]");
                this._wcText1.setValue("");
                getPlayerOwnReports();
            }
        }
    });
});